/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 2012/02/10
Author  :  
Company :  


Chip type               : ATmega32
Program type            : Application
AVR Core Clock frequency: 4.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*****************************************************/

#include <mega32.h>
#include <delay.h>
#include <glcd.h>
#include <string.h>
#include <font5x7.h>
#include <stdlib.h>

unsigned char scan_key(void);

flash unsigned char code[4][4]={
                                {13,14,15,16},{12,10,7,4},
                                {19,9,6,3},{11,8,5,2}
                            };
                            
flash unsigned char sms[10][4] ={
                                {'0','0','0','0'},{'a','b','c','1'},
                                {'d','e','f','2'},{'g','h','i','3'},
                                {'j','k','l','4'},{'m','n','o','5'},
                                {'p','q','r','6'},{'s','t','u','7'},
                                {'v','w','x','8'},{'y','z','0','9'}
                             };


unsigned int x,y,i,y_m,c,d,e,f,key[2],l,j;

unsigned char pimg[1024],monitor[50],img_name[5][50],str[50];
eeprom unsigned char pimg2[1024];
bit paint,read,save,a,b,v,g,h;



unsigned char read_ext_memory(GLCDMEMADDR_t addr)
{
unsigned char data;

return data;
}


void write_ext_memory(GLCDMEMADDR_t addr, unsigned char data)
{

}


#define ADC_VREF_TYPE 0x20


unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}




void main(void)
{


GLCDINIT_t glcd_init_data;

x=0;
y=0;
i=0;
j=0;
h=0;
g=1;
y_m=0;
c=0;
d=0;
e=0;
f=0;
read=0;
save=0;
a=0;
b=0;
v=0;
paint=1;
PORTC=0x00;
DDRC=0xFF;
PORTA=0xF0;
DDRA=0x00;
PORTD=0x00;
DDRD=251;

// ADC initialization
// ADC Clock frequency: 31.250 kHz
// ADC Voltage Reference: AREF pin
// Only the 8 most significant bits of
// the AD conversion result are used
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x83;
// DB0 - PORTD Bit 0
// DB1 - PORTD Bit 1
// DB2 - PORTC Bit 6
// DB3 - PORTD Bit 3
// DB4 - PORTD Bit 4
// DB5 - PORTD Bit 5
// DB6 - PORTD Bit 6
// DB7 - PORTC Bit 0
// E - PORTC Bit 2
// RD /WR - PORTC Bit 1
// RS - PORTD Bit 7
// /RST - PORTC Bit 5
// CS1 - PORTC Bit 3
// CS2 - PORTC Bit 4
glcd_init_data.font=font5x7;
glcd_init_data.readxmem=NULL;
glcd_init_data.writexmem=NULL;

glcd_init(&glcd_init_data);

#asm("sei")
PORTB=0;
DDRB=0xF0;
glcd_outtextxyf(10, 20, "   Iranled.com");
glcd_outtextxyf(10, 40, "    Alibarghi");

d=0;
key[0]=110;
key[1]=110;
while (1)
      {
      PORTB=0;
      DDRB=0xF0;
      if(PINA.4==0||PINA.5==0||PINA.6==0||PINA.7==0){
      key[a]=scan_key();
     
      if(key[a]!=255){     
key[a]=key[a]-1;
b=a;
a =~a ;

g=0;

}
else if(key[a]==255){
g=1;
key[a]=key[b];
}
}else{
g=1;
}
      ////////////////////////////////////////////////////////////////////
      if( paint == 1 ){
      
      PORTA=0xF4;
      DDRA=12;

      y=read_adc(0);
      
      for(i=0;i<4;i++){
      y=y+read_adc(0);
      }
      y=y/5;
      
      y_m=read_adc(0);
      if((y-y_m<2 && y-y_m>0) || (y-y_m>-2 && y-y_m<0)){
      
      y=y-30;
      y = y/2.5;
      
      PORTA=0xF1;
      DDRA=0x03;
   
      x=read_adc(2);
      for(i=0;i<4;i++){
      x=x+read_adc(2);
      }
      x=x/5;
      x=x+7;
      x=x/1.8;
      
      glcd_setpixel(x,y);
      
      }
      
      if ( key[b] == 15 ){
      glcd_clear();
      key[b]=18;
      key[a]=18;
      }
      delay_us(7);
      }
      
      
      if((key[b]== 10 || key[b] == 11)&&g==0 )
        paint = 0;
      /////////////////////////////////////////////////////////////////
      if ( paint == 0 ){///////////////*****************************///////////////////////
      
      
      if ( key[b] ==  10 && read == 0 ){ // save mode 
      
        save = 1 ;
      
      }
      
      if ( key[b] == 11 && save == 0 ){ // read mode  
      
        read = 1;  
      
      } 
      
      
      
      
      ////////////////////////////////SAVE PROGRAM///////////////////////
      if ( save == 1 ){
        if( v == 0){
            if(e==0){
            glcd_getimage(0, 0, 127, 63, pimg);
            }
            if(e==1){
            glcd_getimagee(0, 0, 127, 63, pimg2);
            }
            
            glcd_clear();
            v=1;
            
            }
      
        
        if( key[a] == key [b] && key[b]<10&&g==0) {
            c++;
            if( c == 4 )
            c = 0;
            h=0;
        }
         
        else if( key[b] != key [a] && key[a]<10&&g==0){
        d++;
        c=0;
        h=1;
        }
        
        if( key[b] == 14 && g==0 ){

        //d++;
        if(h==1)
        d--;
        if(d<0)
        d=0;
        monitor[d] =' ';
        c = 0 ; 
        }
        
        if( key[b] == 13 && g==0 ){
        monitor[d] =' ';
        c = 0; 
        
        }
        if(key[b]<10 )
        monitor[d] = sms[ key[b] ][c];
        
        glcd_outtextxy(10, 10, monitor);
        glcd_outtextxyf(50,30,"SAVE MODE");
        
        if( key[b] == 12 ){
        d++;
        monitor[d]='*';
        d = 0;
        
        while( monitor[d] != '*' ){
        img_name[e][d] = monitor[d] ;
        str[d]=img_name[e][d];
        d++;
        }
        img_name[e][d] = '*' ;
        d++;
        while( d < 50 ){
        img_name[e][d] = 0 ;
        d++;
        }
        
        glcd_outtextxy(10, 10,str);
        
        e++;
            if(e==2){
            e=0;
            j=1;
            }
        c = 0;
        v=0;
        paint = 1;
        save = 0 ;
        glcd_clear();
        for(d=0;d<50;d++)
        monitor[d]=0;
        d=0;        
        
        }   
      delay_ms(150);
      }
      ////////////////////////////////READ PROGRAM/////////////////////////////////////
      if( read == 1 ){
      if(v==0){
      v=1;
      glcd_clear();
      }  
        if( key[a] == key [b] && key[b]<10&&g==0) {
            c++;
            if( c == 4 )
            c = 0;
            h=0;
        }
         
        else if( key[a] != key [b] && key[a]<10 &&g==0){
        d++;
        c=0;
        h=1;
        }
        
        if( key[b] == 14 && g==0 ){
        if(h==1)
        d--;
        if(d<0)
        d=0;
        monitor[d] =' ';
        
        c = 0 ; 
        
        }
        
        if( key[b] == 13 && g==0){
        
        
        monitor[d] =' ';
        c = 0; 
        
        } 
        if(key[b]<10)
        monitor[d] = sms[ key[b] ][c];
        
        glcd_outtextxy(10, 10, monitor);
        glcd_outtextxyf(50,30,"READ MODE");
        
        if( key[b] == 12 ){ ////////ENTER
        
        while( d < 50 ){
         monitor[d] = 0 ;
         d++;
        }

        if(j==1)
        l=2;
        if(j==0)
        l=e;
        for(f=0;f<l;f++){

        d=0;
        while(img_name[f][d]!='*'){
        str[d]=img_name[f][d];
        d++;
        } 

        if( strcmp( monitor , str) == 0 ){
            
            glcd_clear();
            if(f==0)
            glcd_putimage(0, 0, pimg, 1);
            if(f==1)
            glcd_putimagee(0, 0, pimg2, 1);
            break;
          }
          else {
            glcd_clear();
            glcd_outtextxyf(0, 30, "THIS NAME ISNOT EXIST");
            }
         }
        c = 0;
        v=0;
        paint = 1;
        read = 0 ;
        for(d=0;d<50;d++)
        monitor[d]=0;
        d=0;
        }   
      delay_ms(150);
      }
///////////////////////////////////////END OF READ PROGRAM////////////////////////////// 
      
      } 
////////////////////////////////////END OF READ ADN SAVE PROGRAM/////////////////////////
      
      }
}
/////////////////////////////////////////////////////////////////////////////////////
unsigned char scan_key(void)	
{                           
	unsigned char i,data,num_key,temp;
	num_key=0xff;	
	temp=0x7F;
	for(i=0;i<4;i++){
		PORTB=temp;     			             
		delay_ms(5);  
		data=PINB & 0x0f;
		if(data==0x07)		
			num_key=code[0][i];
		if(data==0x0B)
			num_key=code[1][i];
		if(data==0x0D)
			num_key=code[2][i];	
		if(data==0x0E)
			num_key=code[3][i];		  	
		temp= ((temp>>=1)  | 0x80) & 0xF0 ;	
		
	}
	return num_key;
}
